<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_tableName'] =  'civicrm_price_field';
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_log'] =  false;
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['enums'] =  array(
            'html_type',
        );
$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['translations'] =  null;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_PriceField extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Price Field
     *
     * @var int unsigned
     */
    var $id;
    /**
     * FK to civicrm_price_set
     *
     * @var int unsigned
     */
    var $price_set_id;
    /**
     * Variable name/programmatic handle for this field
     *
     * @var string
     */
    var $name;
    /**
     * Text for form field label (also friendly name for administering this field)
     *
     * @var string
     */
    var $label;
    /**
     *
     * @var enum('Text', 'Select', 'Radio', 'CheckBox')
     */
    var $html_type;
    /**
     * Enter a quantity for this field?
     *
     * @var boolean
     */
    var $is_enter_qty;
    /**
     * Description and/or help text to display before this field.
     *
     * @var text
     */
    var $help_pre;
    /**
     * Description and/or help text to display after this field.
     *
     * @var text
     */
    var $help_post;
    /**
     * Order in which the fields should appear
     *
     * @var int
     */
    var $weight;
    /**
     * Should the price be displayed next to the label for each option?
     *
     * @var boolean
     */
    var $is_display_amounts;
    /**
     * number of options per line for checkbox and radio
     *
     * @var int unsigned
     */
    var $options_per_line;
    /**
     * Is this price field active
     *
     * @var boolean
     */
    var $is_active;
    /**
     * Is this price field required (value must be > 1)
     *
     * @var boolean
     */
    var $is_required;
    /**
     * If non-zero, do not show this field before the date specified
     *
     * @var datetime
     */
    var $active_on;
    /**
     * If non-zero, do not show this field after the date specified
     *
     * @var datetime
     */
    var $expire_on;
    /**
     * Optional scripting attributes for field
     *
     * @var string
     */
    var $javascript;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_price_field
     */
    function CRM_Core_DAO_PriceField() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_links'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_links'] = array(
                'price_set_id' => 'civicrm_price_set:id',
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'price_set_id' => array(
                    'name' => 'price_set_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'name' => array(
                    'name' => 'name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Name') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'label' => array(
                    'name' => 'label',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Label') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'html_type' => array(
                    'name' => 'html_type',
                    'type' => CRM_UTILS_TYPE_T_ENUM,
                    'title' => ts('Html Type') ,
                    'required' => true,
                ) ,
                'is_enter_qty' => array(
                    'name' => 'is_enter_qty',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'help_pre' => array(
                    'name' => 'help_pre',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Help Pre') ,
                ) ,
                'help_post' => array(
                    'name' => 'help_post',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Help Post') ,
                ) ,
                'weight' => array(
                    'name' => 'weight',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Weight') ,
                ) ,
                'is_display_amounts' => array(
                    'name' => 'is_display_amounts',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'options_per_line' => array(
                    'name' => 'options_per_line',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Options Per Line') ,
                ) ,
                'is_active' => array(
                    'name' => 'is_active',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'is_required' => array(
                    'name' => 'is_required',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'active_on' => array(
                    'name' => 'active_on',
                    'type' => CRM_UTILS_TYPE_T_DATE+CRM_UTILS_TYPE_T_TIME,
                    'title' => ts('Active On') ,
                ) ,
                'expire_on' => array(
                    'name' => 'expire_on',
                    'type' => CRM_UTILS_TYPE_T_DATE+CRM_UTILS_TYPE_T_TIME,
                    'title' => ts('Expire On') ,
                ) ,
                'javascript' => array(
                    'name' => 'javascript',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Javascript') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_import'] = array();
            $fields = &CRM_Core_DAO_PriceField::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_import']['price_field'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_export'] = array();
            $fields = &CRM_Core_DAO_PriceField::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_export']['price_field'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['_export'];
    }
    /**
     * returns an array containing the enum fields of the civicrm_price_field table
     *
     * @return array (reference)  the array of enum fields
     */
     function &getEnums() 
    {
        
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['enums'];
    }
    /**
     * returns a ts()-translated enum value for display purposes
     *
     * @param string $field  the enum field in question
     * @param string $value  the enum value up for translation
     *
     * @return string  the display value of the enum
     */
     function tsEnum($field, $value) 
    {
        
        if (!$GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['translations']) {
            $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['translations'] = array(
                'html_type' => array(
                    'Text' => ts('Text') ,
                    'Select' => ts('Select') ,
                    'Radio' => ts('Radio') ,
                    'CheckBox' => ts('CheckBox') ,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICEFIELD']['translations'][$field][$value];
    }
    /**
     * adds $value['foo_display'] for each $value['foo'] enum from civicrm_price_field
     *
     * @param array $values (reference)  the array up for enhancing
     * @return void
     */
     function addDisplayEnums(&$values) 
    {
        $enumFields = &CRM_Core_DAO_PriceField::getEnums();
        foreach($enumFields as $enum) {
            if (isset($values[$enum])) {
                $values[$enum.'_display'] = CRM_Core_DAO_PriceField::tsEnum($enum, $values[$enum]);
            }
        }
    }
}
?>