<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_tableName'] =  'civicrm_participant_payment';
$GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_fields'] =  null;
$GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_links'] =  null;
$GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_import'] =  null;
$GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_export'] =  null;
$GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Event_DAO_ParticipantPayment extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Participant Payment Id
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Participant Id (FK)
     *
     * @var int unsigned
     */
    var $participant_id;
    /**
     * Table being referenced for payment entity (expected usage is civicrm_contribution).
     *
     * @var string
     */
    var $payment_entity_table;
    /**
     * FK to table with payment record (e.g. civicrm_contribution.id).
     *
     * @var int unsigned
     */
    var $payment_entity_id;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_participant_payment
     */
    function CRM_Event_DAO_ParticipantPayment() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_links'])) {
            $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_links'] = array(
                'participant_id' => 'civicrm_participant:id',
            );
        }
        return $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_fields'])) {
            $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Payment ID') ,
                    'required' => true,
                ) ,
                'participant_id' => array(
                    'name' => 'participant_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Participant ID') ,
                    'required' => true,
                ) ,
                'payment_entity_table' => array(
                    'name' => 'payment_entity_table',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Payment Entity Table') ,
                    'maxlength' => 128,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'payment_entity_id' => array(
                    'name' => 'payment_entity_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
            );
        }
        return $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_import'])) {
            $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_import'] = array();
            $fields = &CRM_Event_DAO_ParticipantPayment::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_import']['participant_payment'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_export'])) {
            $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_export'] = array();
            $fields = &CRM_Event_DAO_ParticipantPayment::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_export']['participant_payment'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_EVENT_DAO_PARTICIPANTPAYMENT']['_export'];
    }
}
?>