<?php

/*
 * Copyright (C) 2007
 * Licensed to CiviCRM under the Academic Free License version 3.0.
 *
 * Written and contributed by Ideal Solution, LLC (http://www.idealso.com)
 *
 */

/**
 * @package CRM
 * @author Marshal Newrock <marshal@idealso.com>
 * $Id: Dummy.php 10854 2007-08-11 21:44:05Z lobo $
 **/

$GLOBALS['_CRM_EVENT_PAYMENT_DUMMY']['_singleton'] =  null;

require_once 'CRM/Core/Payment/Dummy.php';

class CRM_Event_Payment_Dummy extends CRM_Core_Payment_Dummy {
    /** 
     * We only need one instance of this object. So we use the singleton 
     * pattern and cache the instance in this variable 
     *
     * @var object 
     * @static 
     */
    
    
    /**
     * Constructor
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return void
     */
    function CRM_Event_Payment_Dummy( $mode, &$paymentProcessor ) {
        parent::CRM_Core_Payment_Dummy( $mode, $paymentProcessor );
    }

    /**
     * singleton function used to manage this object
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return object
     * @static
     */
     function &singleton( $mode, &$paymentProcessor ) {
        if ($GLOBALS['_CRM_EVENT_PAYMENT_DUMMY']['_singleton'] === null ) {
            $GLOBALS['_CRM_EVENT_PAYMENT_DUMMY']['_singleton'] =& new CRM_Event_Payment_Dummy( $mode, $paymentProcessor );
        }
        return $GLOBALS['_CRM_EVENT_PAYMENT_DUMMY']['_singleton'];
    }

}