<?php

/*
 +--------------------------------------------------------------------+
 | CiviCRM version 1.8                                                |
 +--------------------------------------------------------------------+
 | Copyright CiviCRM LLC (c) 2004-2007                                |
 +--------------------------------------------------------------------+
 | This file is a part of CiviCRM.                                    |
 |                                                                    |
 | CiviCRM is free software; you can copy, modify, and distribute it  |
 | under the terms of the Affero General Public License Version 1,    |
 | March 2002.                                                        |
 |                                                                    |
 | CiviCRM is distributed in the hope that it will be useful, but     |
 | WITHOUT ANY WARRANTY; without even the implied warranty of         |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
 | See the Affero General Public License for more details.            |
 |                                                                    |
 | You should have received a copy of the Affero General Public       |
 | License along with this program; if not, contact CiviCRM LLC       |
 | at info[AT]civicrm[DOT]org.  If you have questions about the       |
 | Affero General Public License or the licensing  of CiviCRM,        |
 | see the CiviCRM license FAQ at http://civicrm.org/licensing        |
 +--------------------------------------------------------------------+
*/

/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */

/**
 * This class holds all the Pseudo constants that are specific to Event. This avoids
 * polluting the core class and isolates the Event
 */
$GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['event'] = null;
$GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantStatus'] = null;
$GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantRole'] = null;

class CRM_Event_PseudoConstant extends CRM_Core_PseudoConstant 
{
    /**
     * Event
     *
     * @var array
     * @static
     */
     
    
    /**
     * Participant Status 
     *
     * @var array
     * @static
     */
     
    
    /**
     * Participant Role
     *
     * @var array
     * @static
     */
     
    
    /**
     * Get all the n events
     *
     * @access public
     * @return array - array reference of all events if any
     * @static
     */
      function &event( $id = null )
    {
        if ( ! $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['event'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['event'],
                                               'CRM_Event_DAO_Event',
                                               false, 'title', 'is_active', null, null);
        }
        if ($id) {
            if (array_key_exists($id, $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['event'])) {
                return $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['event'][$id];
            } else {
                return null;
            }
        }
        return $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['event'];
    }
    
    /**
     * Get all the n participant statuses
     *
     * @access public
     * @return array - array reference of all participant statuses if any
     * @static
     */
      function &participantStatus( $id = null )
    {
        if ( ! $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantStatus'] ) {
            $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantStatus'] = array( );
            require_once "CRM/Core/OptionGroup.php";
            $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantStatus'] = CRM_Core_OptionGroup::values("participant_status");
        }
        
        If( $id ) {
            return $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantStatus'][$id];
        }
        
        return $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantStatus'];
    }
    
    /**
     * Get all the n participant roles
     *
     * @access public
     * @return array - array reference of all participant roles if any
     * @static
     */
      function &participantRole( $id = null )
    {
        if ( ! $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantRole'] ) {
            $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantRole'] = array( );
            require_once "CRM/Core/OptionGroup.php";
            $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantRole'] = CRM_Core_OptionGroup::values("participant_role");
        }
        
        If( $id ) {
            return $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantRole'][$id];
        }
        
        return $GLOBALS['_CRM_EVENT_PSEUDOCONSTANT']['participantRole'];
    }
}
?>